#include <stdio.h>
#include <stdlib.h>

#include "tinyaes/tinyaes.h"

aes_ctx *
aes_init_key(const u8 key[], size_t len)
{
	size_t i;
	aes_ctx *ctx;
	u8 *p;

	if ((ctx = (aes_ctx *)malloc(sizeof(aes_ctx))) == NULL)
		return 0;

	p = (u8 *)ctx;
	for (i = 0; i < sizeof(aes_ctx); i++)
		*p++ = 0;

	ctx->Nr = rijndaelKeySetupEnc(ctx->ek, key, len);
        rijndaelKeySetupDec(ctx->dk, key, len);
        ctx->enc_only = 0;
	return ctx;
}

void
aes_delete_key(aes_ctx *ctx)
{
	memset(ctx, 0, sizeof(aes_ctx));
	free(ctx);
	ctx = NULL;
}
